/*!
 * @nuxt/cli v2.10.1 (c) 2016-2019

 * - All the amazing contributors
 * Released under the MIT License.
 * Website: https://nuxtjs.org
*/
'use strict';

require('path');
require('@nuxt/config');
require('exit');
require('@nuxt/utils');
require('chalk');
require('std-env');
require('wrap-ansi');
require('boxen');
const index$1 = require('./cli-index.js');
require('consola');
require('pretty-bytes');
const banner = require('./cli-banner.js');

const start = {
  name: 'start',
  description: 'Start the application in production mode (the application should be compiled with `nuxt build` first)',
  usage: 'start <dir>',
  options: {
    ...index$1.common,
    ...index$1.server
  },
  async run (cmd) {
    const config = await cmd.getNuxtConfig({ dev: false, _start: true });
    const nuxt = await cmd.getNuxt(config);

    // Listen and show ready banner
    await nuxt.server.listen();
    banner.showBanner(nuxt);
  }
};

exports.default = start;
