import path from 'path';
export default function setupPlugin(options) {
    this.options.build.transpile.push('vuetify/lib');
    const optionsPath = typeof options.frameworkOptions === 'string' && this.nuxt.resolver.resolveAlias(options.frameworkOptions);
    // Register options template
    this.addTemplate({
        fileName: `vuetify/options.${optionsPath && optionsPath.endsWith('ts') ? 'ts' : 'js'}`,
        src: optionsPath || path.resolve(__dirname, '../templates', 'options.js'),
        options: options.frameworkOptions || {}
    });
    // Register plugin
    this.addPlugin({
        fileName: 'vuetify/plugin.js',
        src: path.resolve(__dirname, '../templates', 'plugin.js'),
        options: {
            defaultIconPreset: options.defaultAssets && options.defaultAssets.icons,
            treeShake: true
        }
    });
}
//# sourceMappingURL=plugin.js.map