"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _react = _interopRequireWildcard(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; if (obj != null) { var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ExternalComponent =
/*#__PURE__*/
function (_Component) {
  _inherits(ExternalComponent, _Component);

  function ExternalComponent(props) {
    var _this;

    _classCallCheck(this, ExternalComponent);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ExternalComponent).call(this, props));
    _this.state = {
      loaded: false
    };
    _this.importPromise = _this.importPromise.bind(_assertThisInitialized(_this));
    _this.Component = null;
    return _this;
  }

  _createClass(ExternalComponent, [{
    key: "importPromise",
    value: function importPromise(src) {
      if (!src) {
        return new Promise(function (resolve, reject) {
          reject();
        });
      }

      if (this.props.cors) {
        return require('./corsImport')["default"](src);
      }

      return new Promise(function (resolve) {
        resolve(new Function("return import(\"".concat(src, "\")"))());
      });
    }
  }, {
    key: "componentDidMount",
    value: function componentDidMount() {
      var _this2 = this;

      require('./polyfill');

      var _this$props = this.props,
          src = _this$props.src,
          module = _this$props.module,
          exportName = _this$props["export"];

      if (!src) {
        throw new Error("dynamic-import: no url ".concat(JSON.stringify(this.props, null, 2)));
        return;
      }

      this.importPromise(src).then(function () {
        var requiredComponent = __webpack_require__(module);

        _this2.Component = requiredComponent["default"] ? requiredComponent["default"] : requiredComponent[exportName];

        _this2.setState({
          loaded: true
        });
      })["catch"](function (e) {
        throw new Error("dynamic-import: ".concat(e.message));
      });
    }
  }, {
    key: "render",
    value: function render() {
      var Component = this.Component;
      var loaded = this.state.loaded;
      if (!loaded) return null;

      var _this$props2 = this.props,
          src = _this$props2.src,
          module = _this$props2.module,
          rest = _objectWithoutProperties(_this$props2, ["src", "module"]);

      return _react["default"].createElement(Component, rest);
    }
  }]);

  return ExternalComponent;
}(_react.Component);

ExternalComponent.propTypes = {
  src: _propTypes["default"].oneOfType([_propTypes["default"].func, _propTypes["default"].object, _propTypes["default"].string]).isRequired,
  module: _propTypes["default"].string,
  cors: _propTypes["default"].bool
};
var _default = ExternalComponent;
exports["default"] = _default;