import Vuex from 'vuex'
import Vue from 'vue'
import VuexPersistence from 'vuex-persist'

Vue.use(Vuex)

const vuexLocal = new VuexPersistence({
  storage: window.localStorage
})

const store = ({
  state: {
    username: null // The TV inventory
  },
  
  getters: {
    username: state => {
        return state.username
    }
  },
  
  mutations: {
    updateUser(state, username) {
      debugger//eslint-disable-line
        state.username = username
    },
    resetUser(state){
        state.username = null
    }
  },
  
  actions: {
    updateUser(context, username) {
        context.commit('updateUser', username)
    },
    resetUser(context, username){
        context.commit('resetUser')
    }
  },

  plugins: [vuexLocal.plugin]
})

export default store